"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.babelChain = exports.createBabelChain = void 0;
const preset_1 = require("./preset");
const plugin_1 = require("./plugin");
const plain_1 = require("./plain");
const createBabelChain = () => {
    const presetChain = (0, preset_1.createBabelPresetChain)();
    const pluginChain = (0, plugin_1.createBabelPluginChain)();
    const plainChain = (0, plain_1.createBabelPlainChain)();
    const merge = (other) => {
        presetChain.merge(other.internal.preset);
        pluginChain.merge(other.internal.plugin);
        plainChain.merge(other.internal.plain);
        return chain;
    };
    const toJSON = () => ({
        ...plainChain.toJSON(),
        presets: presetChain.toJSON(),
        plugins: pluginChain.toJSON(),
    });
    const chain = {
        ...plainChain.plain,
        plugin: pluginChain.plugin,
        preset: presetChain.preset,
        toJSON,
        merge,
        get internal() {
            return {
                preset: presetChain,
                plugin: pluginChain,
                plain: plainChain,
            };
        },
    };
    return chain;
};
exports.createBabelChain = createBabelChain;
exports.babelChain = (0, exports.createBabelChain)();
